# Class VMAAllocationInfo.Builder

java.lang.Object
com.io7m.jcoronado.vma.VMAAllocationInfo.Builder

Enclosing class:
  `VMAAllocationInfo`

public static final class VMAAllocationInfo.Builder extends Object
Builds instances of type `VMAAllocationInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VMAAllocationInfo`
  `build()`
  Builds a new `VMAAllocationInfo`.
  `final VMAAllocationInfo.Builder`
  `from(VMAAllocationInfoType instance)`
  Fill a builder with attribute values from the provided `VMAAllocationInfoType` instance.
  `final VMAAllocationInfo.Builder`
  `setDeviceMemory(VulkanDeviceMemoryType deviceMemory)`
  Initializes the optional value `deviceMemory` to deviceMemory.
  `final VMAAllocationInfo.Builder`
  `setDeviceMemory(Optional<? extends VulkanDeviceMemoryType> deviceMemory)`
  Initializes the optional value `deviceMemory` to deviceMemory.
  `final VMAAllocationInfo.Builder`
  `setMemoryType(long memoryType)`
  Initializes the value for the `memoryType` attribute.
  `final VMAAllocationInfo.Builder`
  `setOffset(long offset)`
  Initializes the value for the `offset` attribute.
  `final VMAAllocationInfo.Builder`
  `setSize(long size)`
  Initializes the value for the `size` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VMAAllocationInfo.Builder from(VMAAllocationInfoType instance)
    Fill a builder with attribute values from the provided `VMAAllocationInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMemoryType

    public final VMAAllocationInfo.Builder setMemoryType(long memoryType)
    Initializes the value for the `memoryType` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `memoryType`.

    Parameters:
      `memoryType` - The value for memoryType
    Returns:
      `this` builder for use in a chained invocation

  - ### setDeviceMemory

    public final VMAAllocationInfo.Builder setDeviceMemory(VulkanDeviceMemoryType deviceMemory)
    Initializes the optional value `deviceMemory` to deviceMemory.
    Parameters:
      `deviceMemory` - The value for deviceMemory
    Returns:
      `this` builder for chained invocation

  - ### setDeviceMemory

    public final VMAAllocationInfo.Builder setDeviceMemory(Optional<? extends VulkanDeviceMemoryType> deviceMemory)
    Initializes the optional value `deviceMemory` to deviceMemory.
    Parameters:
      `deviceMemory` - The value for deviceMemory
    Returns:
      `this` builder for use in a chained invocation

  - ### setOffset

    public final VMAAllocationInfo.Builder setOffset(long offset)
    Initializes the value for the `offset` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `offset`.

    Parameters:
      `offset` - The value for offset
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final VMAAllocationInfo.Builder setSize(long size)
    Initializes the value for the `size` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `size`.

    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VMAAllocationInfo build()
    Builds a new `VMAAllocationInfo`.
    Returns:
      An immutable instance of VMAAllocationInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing